#include <stdio.h>
#include "includes.h"

/* all animations */
ANIMATION    big_asteroid_animation[MAX_BIG_ASTEROID_TYPES];
ANIMATION    small_asteroid_animation[MAX_SMALL_ASTEROID_TYPES];
ANIMATION    turret_animation;
ANIMATION    laser_animation;
ANIMATION    small_spinner_animation;
ANIMATION    big_spinner_animation;
ANIMATION    pulsar_animation;
ANIMATION    ufo_animation;
ANIMATION    ufo_bomb_animation;
ANIMATION    magic_bomb_animation;
ANIMATION    explosion_animation;
ANIMATION    shrapnel_animation[MAX_SHRAPNEL_TYPES];
ANIMATION    lives_animation;
ANIMATION    boss1_animation;
ANIMATION    boss1_shield_animation;
ANIMATION    boss2_animation;
ANIMATION    boss3a_animation;
ANIMATION    boss3b_animation;
ANIMATION    boss4_animation;
ANIMATION    boss_laser_gun_animation;
ANIMATION    boss_gun_animation;
ANIMATION    big_laser_animation;

/* sprites used in the game */
BASIC_SPRITE big_asteroid[MAX_BIG_ASTEROIDS];
BASIC_SPRITE small_asteroid[MAX_SMALL_ASTEROIDS];
BASIC_SPRITE turret;
BASIC_SPRITE laser[MAX_LASERS];
BASIC_SPRITE small_spinner[MAX_SMALL_SPINNERS];
BASIC_SPRITE big_spinner[MAX_BIG_SPINNERS];
BASIC_SPRITE pulsar[MAX_PULSARS];
BASIC_SPRITE ufo[MAX_UFOS];
BASIC_SPRITE ufo_bomb[MAX_UFO_BOMBS];
BASIC_SPRITE magic_bomb[MAX_UFO_BOMBS];
BASIC_SPRITE explosion[MAX_EXPLOSIONS];
BASIC_SPRITE shrapnel[MAX_SHRAPNEL];
BASIC_SPRITE boss1;
BASIC_SPRITE boss1_shield[2];
BASIC_SPRITE boss2;
BASIC_SPRITE boss_laser_gun[2]; /* 2 laser guns for use by bosses */
BASIC_SPRITE boss_laser[5];     /* lasers that the bosses can use */
BASIC_SPRITE boss3a[2];
BASIC_SPRITE boss3b;
BASIC_SPRITE boss4;
BASIC_SPRITE boss_gun;
BASIC_SPRITE big_laser;

/* intellivision font */
NCDFONT astro_font;

/* lookup charts for various numbers */
fix drop_speed_chart[10] = { fix(0.5), fix(1), fix(1.5), fix(1.5), fix(1.5), fix(1.5), fix(1.7), fix(2), fix(2), fix(2.2)};
int big_asteroid_score[MAX_LEVELS] = {10, 20, 30, 40, 50, 60, 60, 60, 60};
int small_asteroid_score[MAX_LEVELS] = {20, 40, 60, 80, 100, 120, 120, 120, 120};
int big_spinner_score[MAX_LEVELS] = {40, 80, 120, 160, 200, 240, 240, 240, 240};
int small_spinner_score[MAX_LEVELS] = {80, 160, 240, 320, 400, 480, 480, 480, 480};
int pulsar_score[MAX_LEVELS] = {50, 100, 150, 200, 250, 300, 300, 300, 300};
int ufo_score[MAX_LEVELS] = {100, 200, 300, 400, 500, 600, 600, 600, 600};
int big_asteroid_lose[MAX_LEVELS] = {-5, -10, -15, -20, -25, -30, -30, -30, -30};
int small_asteroid_lose[MAX_LEVELS] = {-10, -20, -30, -40, -50, -60, -60, -60, -60};
int lose_amount[MAX_LEVELS] = {-100, -200, -300, -400, -500, -600, -600, -600, -600};
long level_change[MAX_LEVELS] = {0, 1000, 5000, 20000, 50000, 100000, 200000, 500000, 1000000};
long level_change_deluxe[MAX_LEVELS + 1] = {0, 2500, 7500, 15000, 25000, 37500, 50000, 62500, 75000, 87500};
int level_color[MAX_LEVELS] = {0, 77, 67, 164, 14, 0, 224, 225, 226};
//fix level_multiplier[MAX_LEVELS] = {0.25, 0.5, 0.7, 0.9, 1.0, 1.0, 1.0, 1.0, 1.0};
//int asteroid_prob[MAX_LEVELS] = {44, 50, 57, 67, 80, 100, 133, 200, 400};
int asteroid_prob[MAX_LEVELS] = {40, 70, 100, 100, 130, 160, 170, 170, 170};
int asteroid_split_prob[MAX_LEVELS] = {600, 650, 700, 750, 850, 1000, 1000, 1000, 1000};
int spinner_prob[MAX_LEVELS] = {2, 2, 3, 4, 5, 5, 6, 6, 7};
int pulsar_prob[MAX_LEVELS] = {1, 1, 2, 2, 3, 3, 4, 5, 6};
int ufo_prob[MAX_LEVELS] = {0, 0, 0, 1, 1, 2, 2, 3, 7};
int ufo_fire_time[MAX_LEVELS] = {1, 1, 1, 50, 45, 40, 38, 36, 34};
fix turret_upgrade[MAX_LEVELS] = { fix(2.5), fix(2.6), fix(2.7), fix(2.8), fix(2.9), fix(3.0), fix(3.1), fix(3.2), fix(3.3)};

/* miscellaneous variables */
int lives_up = 1000;
int autofire =    0;
int autofire_on = 0;
int ufofire = 0;
int a_counter = 0;
int big_asteroid_type[MAX_BIG_ASTEROIDS];
char lbrelease = 1;
char rbrelease = 1;
char ubrelease = 1;
int lose = 0;
long score = 0;
long peakscore = 0;
int level = 0;
int lives = 4;
int big_spinner_sframe[MAX_BIG_SPINNERS] = {0, 0}; 
int small_spinner_sframe[MAX_SMALL_SPINNERS] = {0, 0};
int ufo_sframe[MAX_UFOS] = {0};
int astro_state;
int astro_mode;
char astro_quit = 0;
char astro_exited = 0;
int js_on = 0;
char do_settings = 0;
int p_meter;
char bonus_enabled = 0;

/* screen related stuff */
PALETTE astro_palette;
PALETTE game_palette[MAX_LEVELS];
PALETTE death_palette;
BITMAP * astro_screen;
BITMAP * astro_bgpic;

/* sounds */
MSAMPLE * laser_sound;
MSAMPLE * explode_sound;
MSAMPLE * land_sound;
MSAMPLE * one_up_sound;
MSAMPLE * die_sound;
MSAMPLE * missile_sound;
MSAMPLE * spinner_sound;
MSAMPLE * warp_sound;
MSAMPLE * bomb_sound;
MSAMPLE * ufo_sound;
MSAMPLE * hit_sound;
MSAMPLE * big_laser_sound;
MSAMPLE * secret_sound_1;
MSAMPLE * secret_sound_2;

/* high score data */
HISCORES classic_scores;
HISCORES survival_scores;
HISCORES deluxe_scores;

/* title screen stuff */
BITMAP * titlepic;
BITMAP * optionspic;
BITMAP * completepic;
ANIMATION select_animation;
MY_MENU astro_menu[ASTRO_MAX_MENUS];

/* texts used by the menu system */
char * sound_text[2] = {"Off", "On"};
char * soundcard_text[4] = {"Disabled", "Mono", "Stereo", "Reverse Stereo"};
char * joy_text[2] = {"Off", "On"};

/* game options */
unsigned char music_mode = 2; /* Rock */
unsigned char sound_mode = 1;
unsigned char music_volume = 100;
unsigned char sound_volume = 100;
unsigned char joystick_mode = 1;
unsigned char sound_enabled = 2; /* stereo */

/* names of music files */
char * title_music_file[3] = {NULL, DATADIR "astro.dat#title_music_light", DATADIR "astro.dat#title_music_rock"};
char * game_music_file[3]  = {NULL, DATADIR "astro.dat#game_music_light", DATADIR "astro.dat#game_music_rock"};
char * hi_music_file[3]    = {NULL, DATADIR "astro.dat#high_score_music_light", DATADIR "astro.dat#high_score_music_rock"};
char * boss_music_file[3]  = {NULL, DATADIR "astro.dat#boss_music_light", DATADIR "astro.dat#boss_music_rock"};
char * astro_music_name[3] = {"None", "Beat", "Rock"};

PALETTE * change_palette;
int palette_changed;

void astro_request_palette(PALETTE * pp)
{
    change_palette = pp;
    palette_changed = 1;
}

void astro_vsync(void)
{
    if(palette_changed)
    {
        set_palette(*change_palette);
        palette_changed = 0;
    }
    else
    {
        vsync();
    }
}

/* initialize everything */
void astro_init(void)
{
#ifdef __unix__
    int check_and_create_dir(const char *name);
    char *get_home_dir(void);
    char buf[512];
    char *home = get_home_dir();
#endif

    /* allegro initializations */
    allegro_init();
    if(!exists(DATADIR "astro.dat"))
    {
        #ifdef ALLEGRO_WINDOWS
        allegro_message("Game not installed properly!");
        allegro_exit();
        #else
        printf("Game not installed properly!");
        allegro_exit();
        #endif
        exit(1);
    }
    install_keyboard();
    install_mouse();
    install_timer();
    ncd_randomize();
    set_gfx_mode(GFX_AUTODETECT, 640, 480, 0, 0);
    text_mode(-1);

    /* load title screen data */
    titlepic = load_pcx(DATADIR "astro.dat#title", NULL);
    optionspic = load_pcx(DATADIR "astro.dat#options", NULL);
    completepic = load_pcx(DATADIR "astro.dat#level_complete", NULL);
    load_animation(&select_animation, DATADIR "astro.dat#menu_selector");

    /* load game data */
    astro_bgpic = load_pcx(DATADIR "astro.dat#backdrop", astro_palette);
    load_ncdfont(&astro_font, DATADIR "astro.dat#intellivision_font");

    /* load animations */
    load_animation(&big_asteroid_animation[0], DATADIR "astro.dat#big_blue_asteroid");
    load_animation(&big_asteroid_animation[1], DATADIR "astro.dat#big_brown_asteroid");
    load_animation(&big_asteroid_animation[2], DATADIR "astro.dat#big_green_asteroid");
    load_animation(&big_asteroid_animation[3], DATADIR "astro.dat#big_red_asteroid");
    load_animation(&big_asteroid_animation[4], DATADIR "astro.dat#big_yellow_asteroid");
    load_animation(&small_asteroid_animation[0], DATADIR "astro.dat#small_blue_asteroid");
    load_animation(&small_asteroid_animation[1], DATADIR "astro.dat#small_brown_asteroid");
    load_animation(&small_asteroid_animation[2], DATADIR "astro.dat#small_green_asteroid");
    load_animation(&small_asteroid_animation[3], DATADIR "astro.dat#small_red_asteroid");
    load_animation(&small_asteroid_animation[4], DATADIR "astro.dat#small_yellow_asteroid");
    load_animation(&small_spinner_animation, DATADIR "astro.dat#small_spinner");
    load_animation(&big_spinner_animation, DATADIR "astro.dat#big_spinner");
    load_animation(&pulsar_animation, DATADIR "astro.dat#guided_missile");
    load_animation(&ufo_animation, DATADIR "astro.dat#ufo");
    load_animation(&ufo_bomb_animation, DATADIR "astro.dat#ufobomb");
    load_animation(&magic_bomb_animation, DATADIR "astro.dat#magic_bomb");
    load_animation(&turret_animation, DATADIR "astro.dat#turret");
    load_animation(&laser_animation, DATADIR "astro.dat#laser");
    load_animation(&explosion_animation, DATADIR "astro.dat#explosion");
    load_animation(&shrapnel_animation[0], DATADIR "astro.dat#shrapnel0");
    load_animation(&shrapnel_animation[1], DATADIR "astro.dat#shrapnel1");
    load_animation(&lives_animation, DATADIR "astro.dat#lives");
    load_animation(&boss1_animation, DATADIR "astro.dat#boss1");
    load_animation(&boss1_shield_animation, DATADIR "astro.dat#boss_shield");
    load_animation(&boss2_animation, DATADIR "astro.dat#boss2");
    load_animation(&boss_laser_gun_animation, DATADIR "astro.dat#boss_gun");
    load_animation(&boss_gun_animation, DATADIR "astro.dat#boss_gun2");
    load_animation(&boss3a_animation, DATADIR "astro.dat#boss3a");
    load_animation(&boss3b_animation, DATADIR "astro.dat#boss3b");
    load_animation(&boss4_animation, DATADIR "astro.dat#boss4");
    load_animation(&big_laser_animation, DATADIR "astro.dat#big_laser");

    /* prepare the screen */
    astro_screen = create_bitmap(318, 200);
    clear(astro_screen);

    /* load the save files */
#ifdef __unix__
    snprintf(buf, sizeof(buf), "%s/.smashteroid", home? home:".");
    if(check_and_create_dir(buf))
    {
        allegro_exit();
        exit(1);
    }
#endif
    classic_scores.load("classic.hs");
    survival_scores.load("survival.hs");
    deluxe_scores.load("deluxe.hs");
    astro_load_cfg();

    /* do the settings screen if we're supposed to */
    if(do_settings)
    {
        #ifndef ALLEGRO_WINDOWS
        astro_settings();
        #endif
    }

    /* have to check if player hit "play" or "exit" */
    if(!astro_quit)
    {
        /* initialize sound if we're supposed to */
        if(sound_enabled)
        {
            if(!t3ss_init(44100, sound_enabled - 1))
            {
                sound_enabled = 0;
            }
            else
            {
                /* make 8 sound effects channels */
                t3ss_set_effects_channels(8);
                t3ss_set_reserved_channels(2);
                t3ss_set_music_volume(music_volume);
                t3ss_set_sound_volume(sound_volume);
                if(!sound_mode)
                {
                    t3ss_disable_effects();
                }
        
                /* load the sounds */
                laser_sound = t3ss_load_wav_fn(DATADIR "astro.dat#laser_sound");
                explode_sound = t3ss_load_wav_fn(DATADIR "astro.dat#explosion_sound");
                land_sound = t3ss_load_wav_fn(DATADIR "astro.dat#land_sound");
                one_up_sound = t3ss_load_wav_fn(DATADIR "astro.dat#lives_sound");
                die_sound = t3ss_load_wav_fn(DATADIR "astro.dat#death_sound");
                missile_sound = t3ss_load_wav_fn(DATADIR "astro.dat#guided_missile_sound");
                spinner_sound = t3ss_load_wav_fn(DATADIR "astro.dat#spinner_sound");
                warp_sound = t3ss_load_wav_fn(DATADIR "astro.dat#hyperspace_sound");
                bomb_sound = t3ss_load_wav_fn(DATADIR "astro.dat#bomb_sound");
                ufo_sound = t3ss_load_wav_fn(DATADIR "astro.dat#ufo_sound");
                hit_sound = t3ss_load_wav_fn(DATADIR "astro.dat#hit_sound");
                big_laser_sound = t3ss_load_wav_fn(DATADIR "astro.dat#big_laser_sound");
                secret_sound_1 = t3ss_load_wav_fn(DATADIR "astro.dat#secret1");
                secret_sound_2 = t3ss_load_wav_fn(DATADIR "astro.dat#secret2");
            }
        }

        /* initialize joystick if we're supposed to */
        if(joystick_mode == 1)
        {
            ncd_joy_install();
            js_on = ncd_joy_enabled;
        }
        
        for(int i = 0; i < MAX_LEVELS; i++)
        {
            for(int j = 1; j < 256; j++)
            {
                game_palette[i][j].r = astro_palette[j].r;
                game_palette[i][j].g = astro_palette[j].g;
                game_palette[i][j].b = astro_palette[j].b;
            }
            game_palette[i][0].r = astro_palette[level_color[i]].r;
            game_palette[i][0].g = astro_palette[level_color[i]].g;
            game_palette[i][0].b = astro_palette[level_color[i]].b;
        }
        for(int i = 1; i < 256; i++)
        {
            death_palette[i].r = astro_palette[i].r;
            death_palette[i].g = astro_palette[i].g;
            death_palette[i].b = astro_palette[i].b;
        }
        death_palette[0].r = 63;
        death_palette[0].g = 0;
        death_palette[0].b = 0;

        /* get ready for fading */
        set_palette(black_palette);
        
        /* initialize sprites */
        for(int i = 0; i < MAX_BIG_ASTEROIDS; i++)
        {
            big_asteroid[i].initialize(&big_asteroid_animation[ncd_random() % MAX_BIG_ASTEROID_TYPES]);
        }
        for(int i = 0; i < MAX_SMALL_ASTEROIDS; i++)
        {
            small_asteroid[i].initialize(&small_asteroid_animation[ncd_random() % MAX_SMALL_ASTEROID_TYPES]);
        }
        for(int i = 0; i < MAX_LASERS; i++)
        {
            laser[i].initialize(&laser_animation);
        }
        turret.initialize(&turret_animation);
        turret.set_position(fix(153), fix(156));
        turret.set_friction(fix(0.5), fix(0));
        turret.set_acceleration(fix(1), fix(0));
        turret.set_max_speed(fix(2.5), fix(0));
        turret.set_boundary(fix(0), fix(0), fix(304), fix(220), BOUNDARY_STOP);
        turret.set_collision(2, 0, turret_animation.w - 4, turret_animation.h);
        turret.activate();
        for(int i = 0; i < MAX_SMALL_SPINNERS; i++)
        {
            small_spinner[i].initialize(&small_spinner_animation);
            small_spinner[i].set_collision(4, 4, small_spinner_animation.w - 8, small_spinner_animation.h - 8);
        }
        for(int i = 0; i < MAX_BIG_SPINNERS; i++)
        {
            big_spinner[i].initialize(&big_spinner_animation);
            big_spinner[i].set_collision(8, 8, big_spinner_animation.w - 16, big_spinner_animation.h - 16);
        }
        for(int i = 0; i < MAX_PULSARS; i++)
        {
            pulsar[i].initialize(&pulsar_animation);
            pulsar[i].set_acceleration(fix(0), fix(0.25));
        }
        for(int i = 0; i < MAX_UFOS; i++)
        {
            ufo[i].initialize(&ufo_animation);
            ufo[i].set_boundary_past_edge(astro_screen, BOUNDARY_DEACTIVATE);
        }
        for(int i = 0; i < MAX_UFO_BOMBS; i++)
        {
            ufo_bomb[i].initialize(&ufo_bomb_animation);
            ufo_bomb[i].set_boundary_past_edge(astro_screen, BOUNDARY_DEACTIVATE);
            ufo_bomb[i].set_boundary_bottom(fix(172 - ufo_bomb_animation.h), BOUNDARY_DEACTIVATE);
            magic_bomb[i].initialize(&magic_bomb_animation);
            magic_bomb[i].set_boundary_past_edge(astro_screen, BOUNDARY_DEACTIVATE);
            magic_bomb[i].set_boundary_bottom(fix(172 - magic_bomb_animation.h), BOUNDARY_DEACTIVATE);
        }
        for(int i = 0; i < MAX_EXPLOSIONS; i++)
        {
            explosion[i].initialize(&explosion_animation);
            explosion[i].set_life(24);
        }
        for(int i = 0; i < MAX_SHRAPNEL; i++)
        {
            shrapnel[i].initialize(&shrapnel_animation[i % 2]);
        }

        /* initialize bosses */
        boss1.initialize(&boss1_animation);
        boss1.set_flash_color(31);
        boss1_shield[0].initialize(&boss1_shield_animation);
        boss1_shield[0].set_flash_color(31);
        boss1_shield[1].initialize(&boss1_shield_animation);
        boss1_shield[1].set_flash_color(31);
        boss2.initialize(&boss2_animation);
        boss2.set_flash_color(31);
        boss3a[0].initialize(&boss3b_animation);
        boss3a[0].set_flash_color(31);
        boss3a[1].initialize(&boss3b_animation);
        boss3a[1].set_flash_color(31);
        boss3b.initialize(&boss3a_animation);
        boss3b.set_flash_color(31);
        boss4.initialize(&boss4_animation);
        boss4.set_flash_color(31);
        boss_laser_gun[0].initialize(&boss_laser_gun_animation);
        boss_laser_gun[0].set_flash_color(31);
        boss_laser_gun[1].initialize(&boss_laser_gun_animation);
        boss_laser_gun[1].set_flash_color(31);
        boss_gun.initialize(&boss_gun_animation);
        boss_gun.set_flash_color(31);
        for(int i = 0; i < 5; i++)
        {
            boss_laser[i].initialize(&laser_animation);
            boss_laser[i].set_boundary_past_edge(astro_screen, BOUNDARY_DEACTIVATE);
            boss_laser[i].set_boundary_bottom(fix(172 - laser_animation.h), BOUNDARY_DEACTIVATE);
        }
        big_laser.initialize(&big_laser_animation);
    }
}

/* get ready to go back to OS */
void astro_exit(void)
{
    /* save config file */
    astro_save_cfg();

    /* destroy title screen stuff */
    destroy_bitmap(titlepic);
    destroy_bitmap(optionspic);
    destroy_bitmap(completepic);
    destroy_animation(&select_animation);

    /* destroy animations */
    for(int i = 0; i < MAX_BIG_ASTEROID_TYPES; i++)
    {
        destroy_animation(&big_asteroid_animation[i]);
    }
    for(int i = 0; i < MAX_SMALL_ASTEROID_TYPES; i++)
    {
        destroy_animation(&small_asteroid_animation[i]);
    }
    destroy_animation(&laser_animation);
    destroy_animation(&turret_animation);
    destroy_animation(&small_spinner_animation);
    destroy_animation(&big_spinner_animation);
    destroy_animation(&pulsar_animation);
    destroy_animation(&ufo_animation);
    destroy_animation(&ufo_bomb_animation);
    destroy_animation(&magic_bomb_animation);
    destroy_animation(&explosion_animation);
    for(int i = 0; i < MAX_SHRAPNEL_TYPES; i++)
    {
        destroy_animation(&shrapnel_animation[i]);
    }
    destroy_animation(&boss1_animation);
    destroy_animation(&boss1_shield_animation);
    destroy_animation(&boss2_animation);
    destroy_animation(&boss_laser_gun_animation);
    destroy_animation(&boss_gun_animation);
    destroy_animation(&boss3a_animation);
    destroy_animation(&boss3b_animation);
    destroy_animation(&boss4_animation);
    destroy_animation(&lives_animation);

    /* free other stuff */
    destroy_bitmap(astro_bgpic);
    destroy_ncdfont(&astro_font);
    destroy_bitmap(astro_screen);

    /* free sounds */
    t3ss_free_wav(laser_sound);
    t3ss_free_wav(explode_sound);
    t3ss_free_wav(land_sound);
    t3ss_free_wav(one_up_sound);
    t3ss_free_wav(die_sound);
    t3ss_free_wav(missile_sound);
    t3ss_free_wav(spinner_sound);
    t3ss_free_wav(warp_sound);
    t3ss_free_wav(bomb_sound);
    t3ss_free_wav(ufo_sound);
    t3ss_free_wav(hit_sound);
    t3ss_free_wav(big_laser_sound);

    /* remove all handlers and stuff */
    t3ss_exit();
    ncd_joy_remove();
    remove_timer();
    remove_mouse();
    remove_keyboard();
    allegro_exit();
}

/* returns the current level according to the score */
int get_level(void)
{
    if(astro_mode == ASTRO_MODE_CLASSIC || astro_mode == ASTRO_MODE_SURVIVAL)
    {
        if(score < level_change[1])
        {
            return 0;
        }
        else if(score < level_change[2])
        {
            return 1;
        }
        else if(score < level_change[3])
        {
            return 2;
        }
        else if(score < level_change[4])
        {
            return 3;
        }
        else if(score < level_change[5])
        {
            return 4;
        }
        else if(score < level_change[6])
        {
            return 5;
        }
        else if(score < level_change[7])
        {
            return 6;
        }
        else if(score < level_change[8])
        {
            return 7;
        }
        else
        {
            return 8;
        }
    }
    if(astro_mode == ASTRO_MODE_DELUXE)
    {
        if(score < level_change_deluxe[1])
        {
            return 0;
        }
        else if(score < level_change_deluxe[2])
        {
            return 1;
        }
        else if(score < level_change_deluxe[3])
        {
            return 2;
        }
        else if(score < level_change_deluxe[4])
        {
            return 3;
        }
        else if(score < level_change_deluxe[5])
        {
            return 4;
        }
        else if(score < level_change_deluxe[6])
        {
            return 5;
        }
        else if(score < level_change_deluxe[7])
        {
            return 6;
        }
        else if(score < level_change_deluxe[8])
        {
            return 7;
        }
        else if(score < level_change_deluxe[9])
        {
            return 8;
        }
    }
    return 0;
}

/* handles level changes */
void update_level(void)
{
    /* keep up with what level we were on */
    int oldlevel = level;

    /* get the new level and see if it's different than the old */
    level = get_level();
    if(level != oldlevel)
    {
        if(astro_mode == ASTRO_MODE_DELUXE)
        {
            level = oldlevel;

            /* go to boss mode when appropriate */
            if(oldlevel == 1 || oldlevel == 3 || oldlevel == 5 || oldlevel == 8)
            {
                do_boss(oldlevel);
            }

            /* increase the level when we defeat the boss */
            if(level < 8 && !astro_exited)
            {
                level++;
                turret.set_max_speed(turret_upgrade[level], fix(0));
            }
        }

        /* change the background color to match the new level */
        if(!astro_exited)
        {
            astro_request_palette(&game_palette[level]);
        }
    }
}

/* deactivates all sprites */
void deactivate_all(void)
{
    /* initialize sprites */
    for(int i = 0; i < MAX_BIG_ASTEROIDS; i++)
    {
        big_asteroid[i].deactivate();
    }
    for(int i = 0; i < MAX_SMALL_ASTEROIDS; i++)
    {
        small_asteroid[i].deactivate();
    }
    for(int i = 0; i < MAX_LASERS; i++)
    {
        laser[i].deactivate();
    }
    for(int i = 0; i < MAX_SMALL_SPINNERS; i++)
    {
        small_spinner[i].deactivate();
    }
    for(int i = 0; i < MAX_BIG_SPINNERS; i++)
    {
        big_spinner[i].deactivate();
    }
    for(int i = 0; i < MAX_PULSARS; i++)
    {
        pulsar[i].deactivate();
    }
    for(int i = 0; i < MAX_UFOS; i++)
    {
        ufo[i].deactivate();
    }
    for(int i = 0; i < MAX_UFO_BOMBS; i++)
    {
        ufo_bomb[i].deactivate();
        magic_bomb[i].deactivate();
    }
    for(int i = 0; i < MAX_SHRAPNEL; i++)
    {
        shrapnel[i].deactivate();
    }
    for(int i = 0; i < 5; i++)
    {
        boss_laser[i].deactivate();
    }
    big_laser.deactivate();
    turret.deactivate();
    if(astro_state != ASTRO_STATE_BOSS)
    {
        boss_laser_gun[0].deactivate();
        boss_laser_gun[1].deactivate();
        boss1_shield[0].deactivate();
        boss1_shield[1].deactivate();
        boss1.deactivate();
        boss2.deactivate();
        boss3a[0].deactivate();
        boss3a[1].deactivate();
        boss3b.deactivate();
        boss4.deactivate();
        boss_gun.deactivate();
    }
}

/* fire a laser */
void fire_laser(void)
{
    if(astro_state == ASTRO_STATE_PLAYING || astro_state == ASTRO_STATE_BOSS || astro_state == ASTRO_STATE_LEVEL_COMPLETE || astro_state == ASTRO_STATE_GAME_COMPLETE)
    {
        for(int i = 0; i < MAX_LASERS; i++)
        {
            if(!laser[i].active())
            {
                t3ss_play_sound(laser_sound, t3ss_place_sound(turret.get_ox(), 318), I_NULL);
                turret.spawn(&laser[i], fix(6), fix(-11), fix(0), fix(-5));
                if(!(key[KEY_SPACE] || key[KEY_LCONTROL] || key[KEY_RCONTROL] || ncd_joy_button(0, 0)))
                {
                    autofire = 0;
                }
                else
                {
                    autofire = 1;
                }
                lbrelease = 0;
                break;
            }
        }
    }
}

/* do controls */
void astro_control(void)
{
    if(astro_state == ASTRO_STATE_PLAYING || astro_state == ASTRO_STATE_BOSS || astro_state == ASTRO_STATE_LEVEL_COMPLETE || astro_state == ASTRO_STATE_GAME_COMPLETE || astro_state == ASTRO_STATE_DYING)
    {
        /* poll joystick when appropriate */
        ncd_joy_poll();

        /* controls */
        if(key[KEY_LEFT] || ncd_joy_left(0))
        {
            turret.accelerate(-1, 0);
        }
        if(key[KEY_RIGHT] || ncd_joy_right(0))
        {
            turret.accelerate(1, 0);
        }
        if((key[KEY_SPACE] || key[KEY_LCONTROL] || key[KEY_RCONTROL] || ncd_joy_button(0, 0)) && lbrelease)
        {
            fire_laser();
            lbrelease = 0;
        }
        if(!(key[KEY_SPACE] || key[KEY_LCONTROL] || key[KEY_RCONTROL] || ncd_joy_button(0, 0)))
        {
            lbrelease = 1;
        }
        if((key[KEY_UP] || ncd_joy_up(0)) && ubrelease)
        {
            if(autofire_on == 0)
            {
                autofire_on = 1;
                autofire = 0;
            }
            else
            {
                autofire_on = 0;
            }
            ubrelease = 0;
        }
        if(!key[KEY_UP] && !ncd_joy_up(0))
        {
            ubrelease = 1;
        }
        if((key[KEY_DOWN] || ncd_joy_button(0, 1)) && rbrelease)
        {
            t3ss_play_sound(warp_sound, t3ss_place_sound(turret.get_ox(), 318), I_NULL);
            if(key[KEY_LEFT] || ncd_joy_left(0))
            {
                if(turret.get_x() != 0)
                {
                    turret.set_position(fix(ncd_random() % (long) turret.get_x()), fix(156));
                }
            }
            else if(key[KEY_RIGHT] || ncd_joy_right(0))
            {
                if(turret.get_x() != 304)
                {
                     turret.set_position(turret.get_x() + ncd_random() % (long) (304 - turret.get_x()), fix(156));
                }
            }
            else
            {
                turret.set_position(fix(ncd_random() % 304), fix(156));
            }
            turret.set_speed(fix(0), fix(0));
            rbrelease = 0;
        }
        if(!key[KEY_DOWN] && !ncd_joy_button(0, 1))
        {
            rbrelease = 1;
        }

        /* handle autofire */
        if(autofire_on)
        {
            if(autofire % 20 == 0)
            {
                fire_laser();
            }
            autofire++;
        }

        /* cheat keys for debugging and testing */
        if(key[KEY_C] && key[KEY_H] && key[KEY_E] && key[KEY_A] && key[KEY_T])
        {
            level = 8;
            score = 90000;
        }

        /* quit key */
        if(key[KEY_ESC] && astro_state != ASTRO_STATE_GAME_COMPLETE)
        {
            int old_state = astro_state;

            astro_state = ASTRO_STATE_TRY_QUIT;
            while(1)
            {
                if(key[KEY_Y])
                {
                    astro_exited = 1;
                    break;
                }
                else if(key[KEY_N])
                {
                    astro_exited = 0;
                    astro_state = old_state;
                    break;
                }
                astro_update();
            }
        }
    }
}

/* move all sprites */
void astro_move_sprites(void)
{
    if(!astro_exited)
    {
        do_asteroids();
        do_spinners();
        do_pulsars();
        do_ufos();
        do_lasers();
        do_turret();

        /* do 1ups */
        if(score >= lives_up && (astro_mode == ASTRO_MODE_CLASSIC || astro_mode == ASTRO_MODE_DELUXE) && astro_state != ASTRO_STATE_GAME_COMPLETE && astro_state != ASTRO_STATE_GAME_OVER)
        {
            t3ss_play_sound_reserved(one_up_sound, 0, I_NULL, I_NULL);
            lives++;
            if(astro_mode == ASTRO_MODE_CLASSIC)
            {
                lives_up += 1000;
            }
            else if(astro_mode == ASTRO_MODE_DELUXE)
            {
                lives_up += 4000;
            }
        }
    }
}

/* draws lives we have left */
void draw_lives(void)
{
    /* draw with pictures */
    if(lives - 1 < 8)
    {
        for(int i = 0; i < lives - 1; i++)
        {
            draw_animation(&lives_animation, 0, astro_screen, LIVES_X + 16 * i, LIVES_Y);
        }
    }

    /* or numbers appropriately */
    else
    {
        draw_animation(&lives_animation, 0, astro_screen, LIVES_X, LIVES_Y);
        ncd_text_mode(1);
        ncd_text_color(51);
        ncd_draw_number_left(astro_screen, &astro_font, LIVES_X + 16, SCORE_Y, lives - 1, 7);
        ncd_text_mode(0);
    }
}

/* draw everything */
void astro_update(void)
{
    /* draw the background first */
    blit(astro_bgpic, astro_screen, 0, 0, 0, 0, 318, 200);

    /* if it's game over draw these */
    if(astro_state == ASTRO_STATE_GAME_OVER)
    {
        ncd_printf(astro_screen, &astro_font, GO_X, GO_Y, "Game Over");
        ncd_printf(astro_screen, &astro_font, GO_X, GO_Y + 32, "Peak Score%7d", peakscore);
    }

    /* draw all asteroids */
    for(int i = 0; i < MAX_BIG_ASTEROIDS; i++)
    {
        big_asteroid[i].draw(astro_screen);
    }
    for(int i = 0; i < MAX_SMALL_ASTEROIDS; i++)
    {
        small_asteroid[i].draw(astro_screen);
    }

    /* draw all spinners */
    for(int i = 0; i < MAX_SMALL_SPINNERS; i++)
    {
        small_spinner[i].draw(astro_screen);
    }
    for(int i = 0; i < MAX_BIG_SPINNERS; i++)
    {
        big_spinner[i].draw(astro_screen);
    }

    /* draw pulsars */
    for(int i = 0; i < MAX_PULSARS; i++)
    {
        pulsar[i].draw(astro_screen);
    }

    /* draw ufos */
    for(int i = 0; i < MAX_UFOS; i++)
    {
        ufo[i].draw(astro_screen);
    }

    /* draw bosses */
    boss1.draw(astro_screen);
    boss1_shield[0].draw(astro_screen);
    boss1_shield[1].draw(astro_screen);
    boss2.draw(astro_screen);
    boss3b.draw(astro_screen);
    boss3a[0].draw(astro_screen);
    boss3a[1].draw(astro_screen);
    boss_laser_gun[1].draw(astro_screen);

    /* draw last boss */
    if(b4_angle < 128)
    {
        boss_laser_gun[0].draw(astro_screen);
        boss_gun.draw(astro_screen);
        big_laser.draw(astro_screen);
        boss4.draw(astro_screen);
    }
    else
    {
        big_laser.draw(astro_screen);
        boss4.draw(astro_screen);
        boss_gun.draw(astro_screen);
        boss_laser_gun[0].draw(astro_screen);
    }

    /* draw projectiles */
    for(int i = 0; i < 5; i++)
    {
        boss_laser[i].draw(astro_screen);
    }
    for(int i = 0; i < MAX_UFO_BOMBS; i++)
    {
        ufo_bomb[i].draw(astro_screen);
        magic_bomb[i].draw(astro_screen);
    }
    for(int i = 0; i < MAX_EXPLOSIONS; i++)
    {
        explosion[i].draw(astro_screen);
    }
    for(int i = 0; i < MAX_LASERS; i++)
    {
        laser[i].draw(astro_screen);
    }
    for(int i = 0; i < MAX_SHRAPNEL; i++)
    {
        shrapnel[i].draw(astro_screen);
    }

    /* draw turret */
    turret.draw(astro_screen);

    /* update the status bar */
    ncd_draw_number_right(astro_screen, &astro_font, SCORE_X, SCORE_Y, score, 7);
    ncd_printf(astro_screen, &astro_font, LEVEL_X, LEVEL_Y, "%dx", level + 1);
    draw_lives();

    /* draw boss life meter */
    if(astro_state == ASTRO_STATE_BOSS)
    {
        rectfill(astro_screen, 304, 54 - ((p_meter / 4) * 2), 314, 55, 31);
    }

    /* if level is done, draw the message */
    if(astro_state == ASTRO_STATE_LEVEL_COMPLETE)
    {
        a_counter++;
        if(a_counter % 2 == 0)
        {
            ncd_printf_center(astro_screen, &astro_font, 0, 78, "Level Complete");
        }
    }

    if(astro_state == ASTRO_STATE_TRY_QUIT)
    {
        ncd_printf_center(astro_screen, &astro_font, 0, 78, "Quit[Y-N]");
    }

    /* blit to screen */
    astro_vsync();
    stretch_blit(astro_screen, screen, 0, 0, 318, 200, 1*2, 0*2, 318*2, 480);
}

/* do death sequence */
void astro_death(void)
{
    /* play the sound */
    t3ss_play_sound(die_sound, t3ss_place_sound(turret.get_ox(), 318), I_NULL);

    /* lose points when appropriate */
    if(astro_mode == ASTRO_MODE_CLASSIC)
    {
        score += lose_amount[level];
    }

    /* lose a life */
    lives--;

    /* deactivate all sprites */
    deactivate_all();

    /* change the background color */
    astro_request_palette(&death_palette);

    /* spawn shrapnel and deactivate turret */
    turret.spawn(&shrapnel[0], fix(0), fix(0), fix(-1.5), fix(0));
    turret.spawn(&shrapnel[1], fix(0), fix(0), fix(-1), fix(-1));
    turret.spawn(&shrapnel[2], fix(0), fix(0), fix(0), fix(-1.5));
    turret.spawn(&shrapnel[3], fix(0), fix(0), fix(1), fix(-1));
    turret.spawn(&shrapnel[4], fix(0), fix(0), fix(1.5), fix(0));
    turret.deactivate();

    int old_state = astro_state;
    astro_state = ASTRO_STATE_DYING;

    /* do this for 90 frames */
    for(int i = 0; i < 90 && !astro_exited; i++)
    {
        /* move the shrapnel */
        for(int i = 0; i < MAX_SHRAPNEL; i++)
        {
            shrapnel[i].update_position();
        }

        /* keep polling joystick (fixed a glitch) */
        astro_control();

        /* draw everything */
        astro_update();
    }

    if(!astro_exited)
    {
        /* deactivate the shrapnel */
        for(int i = 0; i < MAX_SHRAPNEL; i++)
        {
            shrapnel[i].deactivate();
        }

        /* if we have lives left change color back to normal and reactivate turret */
        if(lives > 0)
        {
            astro_request_palette(&game_palette[level]);
            turret.set_position(fix(153), fix(156));
            turret.activate();
            astro_state = old_state;
        }

        /* otherwise it's game over */
        else
        {
            astro_state = ASTRO_STATE_GAME_OVER;
        }
    }
}

/* do the game over screen */
void astro_game_over(void)
{
    if(astro_state == ASTRO_STATE_GAME_OVER)
    {
        /* deactivate all sprites */
        deactivate_all();

        /* change background color */
        astro_request_palette(&death_palette);

        /* wait for keypress */
        clear_keybuf();
        while(!keypressed())
        {
            /* move the sprites and update the screen */
            astro_move_sprites();
            astro_update();
        }

        /* return the background color to 0 for next game */
        deactivate_all();
    }
    else if(astro_state == ASTRO_STATE_GAME_COMPLETE)
    {
        do_win_sequence();
    }
}

/* see if current score is the best so far */
void get_peak_score(void)
{
    if(score > 9999999)
    {
        score = 9999999;
    }
    if(score > peakscore)
    {
        peakscore = score;
    }
}

void astro_play_classic(void)
{
    /* initialize relevant variables */
    lives = 4;
    lives_up = 1000;
    score = 0;
    peakscore = 0;
    level = 0;
    astro_exited = 0;
    astro_mode = ASTRO_MODE_CLASSIC;

    /* set the proper game state */
    t3ss_play_mod(game_music_file[music_mode]);
    astro_state = ASTRO_STATE_PLAYING;
    autofire_on = 0;
    deactivate_all();

    /* put the turret in the middle and activate */
    turret.set_position(fix(153), fix(156));
    turret.set_max_speed(fix(2.5), fix(0));
    turret.activate();

    /* draw the background and fade in */
    clear(screen);
    astro_update();
    fade_in(astro_palette, 2);

    /* do this until the player hits ESC or runs out of lives */
    while(!astro_exited && lives > 0 && astro_state != ASTRO_STATE_GAME_COMPLETE && astro_state != ASTRO_STATE_GAME_OVER)
    {
        astro_control();
        astro_move_sprites();
        get_peak_score();
        update_level();
        astro_update();
    }

    /* stop the music */
    t3ss_stop_mod();
    t3ss_play_mod(NULL);

    /* do game over screen */
    astro_game_over();

    /* fade and go to high scores */
    fade_out(2);
    t3ss_stop_mod();
    astro_hiscores(&classic_scores);
    classic_scores.save("classic.hs");
}

void astro_play_survival(void)
{
    /* initialize relevant variables */
    lives = 10;
    score = 0;
    peakscore = 0;
    level = 0;
    astro_exited = 0;
    astro_mode = ASTRO_MODE_SURVIVAL;
    autofire_on = 0;
    deactivate_all();

    /* set the proper game state */
    t3ss_play_mod(game_music_file[music_mode]);
    astro_state = ASTRO_STATE_PLAYING;

    /* put the turret in the middle and activate */
    turret.set_position(fix(153), fix(156));
    turret.set_max_speed(fix(2.5), fix(0));
    turret.activate();

    /* draw the background and fade in */
    clear(screen);
    astro_update();
    fade_in(astro_palette, 2);

    /* do this until the player hits ESC or runs out of lives */
    while(!astro_exited && lives > 0 && astro_state != ASTRO_STATE_GAME_COMPLETE && astro_state != ASTRO_STATE_GAME_OVER)
    {
        astro_control();
        astro_move_sprites();
        get_peak_score();
        update_level();
        astro_update();
    }

    /* stop the music */
    t3ss_stop_mod();
    t3ss_play_mod(NULL);

    /* do game over screen */
    astro_game_over();

    /* fade and go to high scores */
    fade_out(2);
    t3ss_stop_mod();
    astro_hiscores(&survival_scores);
    survival_scores.save("survival.hs");
}

void astro_play_deluxe(void)
{
    /* initialize relevant variables */
    lives = 4;
    lives_up = 4000;
    score = 0;
    peakscore = 0;
    level = 0;
    astro_exited = 0;
    astro_mode = ASTRO_MODE_DELUXE;
    autofire_on = 0;
    deactivate_all();

    /* set the proper game state */
    t3ss_play_mod(game_music_file[music_mode]);
    astro_state = ASTRO_STATE_PLAYING;

    /* put the turret in the middle and activate */
    turret.set_position(fix(153), fix(156));
    turret.set_max_speed(fix(2.5), fix(0));
    turret.activate();

    /* draw the background and fade in */
    clear(screen);
    astro_update();
    fade_in(astro_palette, 2);

    /* do this until the player hits ESC or runs out of lives */
    while(!astro_exited && lives > 0 && astro_state != ASTRO_STATE_GAME_COMPLETE && astro_state != ASTRO_STATE_GAME_OVER)
    {
        astro_control();
        astro_move_sprites();
        get_peak_score();
        update_level();
        astro_update();
    }

    /* stop the music */
    t3ss_stop_mod();
    t3ss_play_mod(NULL);

    /* do game over screen */
    astro_game_over();

    /* fade and go to high scores */
    fade_out(2);
    t3ss_stop_mod();
    astro_hiscores(&deluxe_scores);
    deluxe_scores.save("deluxe.hs");
}

void ncd_logo(char * fn, int num)
{
    BITMAP * image;
    PALETTE  palette;
    PALETTE  white_palette;
    int i;

    for(i = 0; i < 256; i++)
    {
        white_palette[i].r = 63;
        white_palette[i].g = 63;
        white_palette[i].b = 63;
    }
    image = load_pcx(fn, palette);
    set_palette(black_palette);
    stretch_blit(image, screen, 0, 0, 320, 240, 0*2, 0*2, 320*2, 240*2);
    fade_in(palette, 2);
    for(i = 0; i < 180 && !key[KEY_ESC] && !key[KEY_SPACE] && !key[KEY_ENTER]; i++)
    {
        vsync();
    }
    fade_from(palette, white_palette, 2);
    fade_out(2);
}

/* the main routine */
void astro_main(void)
{
    /* if we haven't quit yet do this stuff */
    if(!astro_quit)
    {
        /* show the logo */
        ncd_logo(DATADIR "astro.dat#ncd_logo", 0);

        /* head over to the title screen */
        astro_title();
    }
}

/* returns random numbers in fixed type */
fix frandom(int range)
{
    return fix(ncd_random() % range);
}

/* a little chance calculator */
int chance(int prob, int total)
{
    if(ncd_random() % total < prob)
    {
        return 1;
    }
    else
    {
        return 0;
    }
}

int main(int argc, char * argv[])
{
    /* see if we want to do the configuration screen */
    if(argc > 1)
    {
        for(int i = 1; i < argc; i++)
        {
            if(!stricmp(argv[i], "-c") || !stricmp(argv[i], "-C"))
            {
                do_settings = 1;
                break;
            }
            if(!stricmp(argv[i], "-v") || !stricmp(argv[i], "-V"))
            {
                #ifdef ALLEGRO_WINDOWS
                allegro_init();
                allegro_message(VERSION_INFO);
                allegro_exit();
                #else
                printf(VERSION_INFO);
                #endif
                return 1;
            }
        }
    }

    /* initialize */
    astro_init();

    /* run */
    astro_main();

    /* exit */
    astro_exit();

    return 0;
}
END_OF_MAIN()
