#include "includes.h"

int boss_state = 0;
unsigned char anglea = 64;
unsigned char angleb = 192;
fix shield_d(40);
int boss1_fire = 0;
int boss2_fire = 0;
int boss2_charge = 0;
int misc_counter = 0;
int misc_counter2 = 0;
fix b3_distance(11);
int boss3_fire = 0;
int boss_sframe = 0;
fix b4_distance(60);
fix b4_x(146);
int big_laser_frame = 0;
unsigned char b4_angle = 0;
fix tempvol;

int ready_for_boss(void)
{
        if(tempvol > 0)
        {
                tempvol -= 0.25;
                t3ss_set_music_volume(tempvol);
                return 0;
        }
        for(int i = 0; i < MAX_BIG_ASTEROIDS; i++)
        {
                if(big_asteroid[i].active())
                {
                        return 0;
                }
        }
        for(int i = 0; i < MAX_SMALL_ASTEROIDS; i++)
        {
                if(small_asteroid[i].active())
                {
                        return 0;
                }
        }
        for(int i = 0; i < MAX_BIG_SPINNERS; i++)
        {
                if(big_spinner[i].active())
                {
                        return 0;
                }
        }
        for(int i = 0; i< MAX_SMALL_SPINNERS; i++)
        {
                if(small_spinner[i].active())
                {
                        return 0;
                }
        }
        for(int i = 0; i < MAX_PULSARS; i++)
        {
                if(pulsar[i].active())
                {
                        return 0;
                }
        }
        for(int i = 0; i < MAX_UFOS; i++)
        {
                if(ufo[i].active())
                {
                        return 0;
                }
        }
        for(int i = 0; i < MAX_UFO_BOMBS; i++)
        {
                if(ufo_bomb[i].active())
                {
                        return 0;
                }
        }
        t3ss_stop_mod();
        t3ss_set_music_volume(music_volume);
        t3ss_play_mod(boss_music_file[music_mode]);
        return 1;
}

int explosions_done(void)
{
        for(int i = 0; i < MAX_EXPLOSIONS; i++)
        {
                if(explosion[i].active())
                {
                        return 0;
                }
        }
        return 1;
}

void do_endlevel(void)
{
        if(!astro_exited && astro_state != ASTRO_STATE_GAME_OVER)
        {
                clear_keybuf();
                while(!key[KEY_ENTER] && !astro_exited && !explosions_done())
                {
                        astro_control();
                        astro_move_sprites();
                        astro_update();
                }
                astro_state = ASTRO_STATE_LEVEL_COMPLETE;
        }
}

void generate_boss_laser(BASIC_SPRITE * sp)
{
        for(int i = 0; i < 5; i++)
        {
                if(!boss_laser[i].active())
                {
                        sp->spawn_center(&boss_laser[i], fix(0), fix(230), fix(0), fix(3));
                        break;
                }
        }
}

void generate_boss_bomb(BASIC_SPRITE * sp)
{
        for(int i = 0; i < MAX_UFO_BOMBS; i++)
        {
                if(!magic_bomb[i].active())
                {
                        t3ss_play_sound(bomb_sound, t3ss_place_sound(sp->get_ox(), 318), I_NULL);
                        sp->spawn_center(&magic_bomb[i], fix(0), fix(13), fix(0), fix(0));
                        magic_bomb[i].follow_center(&turret, 3);
                        break;
                }
        }
}

void do_boss1(void)
{
        if(boss_state == B1_INACTIVE && ready_for_boss())
        {
                boss1.set_position(fix(-120), fix(20));
                boss1.set_speed(fix(0.75), fix(0));
                boss1.activate();
                boss1.spawn_center(&boss1_shield[0], -shield_d, fix(0), fix(0), fix(0));
                boss1.spawn_center(&boss1_shield[1], shield_d, fix(0), fix(0), fix(0));
                boss_state = B1_APPROACH;
        }
        boss1.update_position();
        boss1_shield[0].set_position(shield_d * cos(fix(anglea)) + boss1.get_ox() - 8, shield_d * sin(fix(anglea)) + boss1.get_oy() - 8);
        boss1_shield[1].set_position(shield_d * cos(fix(angleb)) + boss1.get_ox() - 8, shield_d * sin(fix(angleb)) + boss1.get_oy() - 7);
        if(boss_state != B1_INACTIVE)
        {
                anglea++;
                angleb++;
        }
        if(boss1.get_x() >= 0 && boss_state == B1_APPROACH)
        {
                boss1.set_speed(fix(0.75), fix(0));
                boss_state = B1_RIGHT;
        }
        if(boss1.get_ox() < 120 && boss_state == B1_LEFT)
        {
                boss1.set_speed(fix(0.75), fix(0));
                boss_state = B1_RIGHT;
        }
        if(boss1.get_ox() > 200 && boss_state == B1_RIGHT)
        {
                boss1.set_speed(fix(-0.75), fix(0));
                boss_state = B1_LEFT;
        }
        if(boss1_fire >= 20 && (boss_state == B1_LEFT || boss_state == B1_RIGHT))
        {
                for(int i = 0; i < MAX_UFO_BOMBS; i++)
                {
                        if(!magic_bomb[i].active())
                        {
                                t3ss_play_sound(bomb_sound, t3ss_place_sound(boss1.get_ox(), 318), I_NULL);
                                boss1.spawn_center(&magic_bomb[i], fix(0), fix(20), fix(0), fix(0));
                                magic_bomb[i].follow_center(&turret, 3);
                                break;
                        }
                }
                boss1_fire = 0;
        }
        boss1_fire++;
        if(boss1.active())
        {
                if(boss_sframe % 20 == 0)
                {
                        t3ss_play_sound(ufo_sound, t3ss_place_sound(boss1.get_ox(), 318), I_NULL);
                }
                boss_sframe++;
        }
}

void do_boss2(void)
{
        /* if we're ready for the boss to show up */
        if(boss_state == B2_INACTIVE && ready_for_boss())
        {
                boss2.set_position(fix(125), fix(-60));
                boss2.set_speed(fix(0), fix(0.75));
                boss2.activate();
                boss2.spawn(&boss_laser_gun[0], fix(-18), fix(9), fix(0), fix(0));
                boss2.spawn(&boss_laser_gun[1], fix(70), fix(9), fix(0), fix(0));
                boss_state = B2_APPROACH;
        }

        /* move the boss */
        if(boss_state != B2_INACTIVE)
        {
                boss2.update_position();
                boss2.spawn(&boss_laser_gun[0], fix(-18), fix(9), fix(0), fix(0));
                boss2.spawn(&boss_laser_gun[1], fix(70), fix(9), fix(0), fix(0));
        }

        /* see if we end approach */
        if(boss2.get_y() >= 20 && boss_state == B2_APPROACH)
        {
                boss2.set_speed(fix(0.75), fix(0));
                boss_state = B2_RIGHT;
        }

        /* when we hit the far left of the path, switch to right */
        if(boss2.get_ox() < 120 && boss_state == B2_LEFT)
        {
                boss2.set_speed(fix(0.75), fix(0));
                misc_counter++;
                boss_state = B2_RIGHT;
        }

        /* when we hit the far right, switch to left */
        if(boss2.get_ox() > 200 && boss_state == B2_RIGHT)
        {
                boss2.set_speed(fix(-0.75), fix(0));
                misc_counter++;
                boss_state = B2_LEFT;
        }
        if(misc_counter >= 3)
        if(misc_counter >= 3 && (int)boss2.get_ox() == 159)
        {
                misc_counter = 0;
                if(boss_state == B2_LEFT)
                {
                        boss_state = B2_CHARGE_L;
                        boss2.set_speed(fix(0), fix(0));
                }
                else if(boss_state == B2_RIGHT)
                {
                        boss_state = B2_CHARGE_R;
                        boss2.set_speed(fix(0), fix(0));
                }
        }
        if(boss_state == B2_CHARGE_L || boss_state == B2_CHARGE_R)
        {
                boss2_charge++;
                if(boss2_charge >= 60)
                {
                        if(boss2_charge == 80)
                        {
                                t3ss_play_sound(bomb_sound, t3ss_place_sound(boss2.get_ox(), 318), I_NULL);
                                boss2.spawn_center(&magic_bomb[0], fix(-12), fix(22), -sqrt(fix(8)), sqrt(fix(8)));
                        }
                        if(boss2_charge == 90)
                        {
                                t3ss_play_sound(bomb_sound, t3ss_place_sound(boss2.get_ox(), 318), I_NULL);
                                boss2.spawn_center(&magic_bomb[1], fix(0), fix(22), fix(0), fix(4));
                        }
                        if(boss2_charge == 100)
                        {
                                t3ss_play_sound(bomb_sound, t3ss_place_sound(boss2.get_ox(), 318), I_NULL);
                                boss2.spawn_center(&magic_bomb[2], fix(12), fix(22), sqrt(fix(8)), sqrt(fix(8)));
                        }
                        if(boss2_charge == 110)
                        {
                                t3ss_play_sound(bomb_sound, t3ss_place_sound(boss2.get_ox(), 318), I_NULL);
                                boss2.spawn_center(&magic_bomb[3], fix(12), fix(22), sqrt(fix(8)), sqrt(fix(8)));
                        }
                        if(boss2_charge == 120)
                        {
                                t3ss_play_sound(bomb_sound, t3ss_place_sound(boss2.get_ox(), 318), I_NULL);
                                boss2.spawn_center(&magic_bomb[4], fix(0), fix(22), fix(0), fix(4));
                        }
                        if(boss2_charge == 130)
                        {
                                t3ss_play_sound(bomb_sound, t3ss_place_sound(boss2.get_ox(), 318), I_NULL);
                                boss2.spawn_center(&magic_bomb[5], fix(-12), fix(22), -sqrt(fix(8)), sqrt(fix(8)));
                        }
                        if(boss_state == B2_CHARGE_L && boss2_charge >= 170)
                        {
                                boss2.set_speed(fix(-0.75), fix(0));
                                boss_state = B2_LEFT;
                                boss2_charge = 0;
                        }
                        else if(boss_state == B2_CHARGE_R && boss2_charge >= 140)
                        {
                                boss2.set_speed(fix(0.75), fix(0));
                                boss_state = B2_RIGHT;
                                boss2_charge = 0;
                        }
                }
        }
        boss2_fire++;
        if(boss2_fire >= 15 && (boss_state == B2_LEFT || boss_state == B2_RIGHT))
        {
                generate_boss_laser(&boss_laser_gun[misc_counter2 % 2]);
                t3ss_play_sound(bomb_sound, t3ss_place_sound(boss_laser_gun[misc_counter2 % 2].get_ox(), 318), I_NULL);
                misc_counter2++;
                boss2_fire = 0;
        }
        if(boss2.active())
        {
                if(boss_sframe % 20 == 0)
                {
                        t3ss_play_sound(ufo_sound, t3ss_place_sound(boss2.get_ox(), 318), I_NULL);
                }
                boss_sframe++;
        }
}

void do_boss3(void)
{
        if(boss_state == B3_INACTIVE && ready_for_boss())
        {
                boss3b.set_position(fix(143), fix(-60));
                boss3b.spawn_center(&boss3a[0], -b3_distance, fix(0), fix(0), fix(0));
                boss3b.spawn_center(&boss3a[1], b3_distance, fix(0), fix(0), fix(0));
                boss3b.set_speed(fix(0), fix(0.75));
                boss3b.activate();
                boss_state = B3_APPROACH;
        }
        if(boss_state != B3_INACTIVE)
        {
                boss3b.update_position();
                boss3b.spawn_center(&boss3a[0], -b3_distance, fix(0), fix(0), fix(0));
                boss3b.spawn_center(&boss3a[1], b3_distance, fix(0), fix(0), fix(0));
        }
        if(boss3b.get_y() >= 20 && boss_state == B3_APPROACH)
        {
                boss3b.set_speed(fix(0), fix(0));
                boss3a[0].set_speed(fix(0), fix(0));
                boss3a[1].set_speed(fix(0), fix(0));
                boss_state = B3_WAIT;
        }
        if(boss_state == B3_WAIT)
        {
                misc_counter++;
                if(misc_counter >= 300)
                {
                        misc_counter = 0;
                        boss_state = B3_OPENING;
                }
        }
        if(boss_state == B3_OPENING)
        {
                b3_distance++;
                if(b3_distance >= 29)
                {
                        misc_counter2 = 0;
                        boss3_fire = 0;
                        boss_state = B3_FIRING;
                }
        }
        if(boss_state == B3_FIRING)
        {
                boss3_fire++;
                if(boss3_fire % 10 == 0)
                {
                        for(int i = 0; i < MAX_UFO_BOMBS; i++)
                        {
                                if(!magic_bomb[i].active())
                                {
                                        t3ss_play_sound(bomb_sound, t3ss_place_sound(boss3b.get_ox(), 318), I_NULL);
                                        boss3b.spawn_center(&magic_bomb[i], fix(0), fix(20), fix(0), fix(0));
                                        magic_bomb[i].follow_center(&turret, 3);
                                        misc_counter2++;
                                        if(misc_counter2 >= 10)
                                        {
                                                boss_state = B3_CLOSING;
                                        }
                                        break;
                                }
                        }
                }
        }
        if(boss_state == B3_CLOSING)
        {
                b3_distance--;
                if(b3_distance <= 11)
                {
                        boss_state = B3_WAIT;
                }
        }
        if(boss3b.active())
        {
                if(boss_sframe % 20 == 0)
                {
                        t3ss_play_sound(ufo_sound, t3ss_place_sound(boss3b.get_ox(), 318), I_NULL);
                }
                boss_sframe++;
        }
}

void do_boss4(void)
{
        if(boss_state == B4_INACTIVE && ready_for_boss())
        {
                boss4.set_position(fix(146), fix(-60));
                boss4.spawn_center(&boss_laser_gun[0], b4_distance * cos(fix(b4_angle)), fix(10), fix(0), fix(0));
                boss4.spawn_center(&boss_gun, (b4_distance / 2) * cos(fix(b4_angle)), fix(4),  fix(0), fix(0));
                boss4.set_speed(fix(0), fix(0.75));
                boss4.activate();
                boss_state = B4_APPROACH;
        }
        if(boss_state != B4_INACTIVE)
        {
                boss4.update_position();
                boss4.set_position(fix(146 + 40 * cos(fix(b4_angle))), boss4.get_y());
                if(boss_state == B4_APPROACH)
                {
                        boss4.set_speed(fix(0), fix(0.75));
                }
                boss4.spawn_center(&boss_laser_gun[0], b4_distance * cos(fix(b4_angle)), fix(10), fix(0), fix(0));
                boss4.spawn_center(&boss_gun, (b4_distance / 2) * cos(fix(b4_angle)), fix(4), fix(0), fix(0));
                big_laser.set_position(boss4.get_x() + 8, boss4.get_y() + 28);
                if(boss_state == B4_HUGELASER)
                {
                        b4_angle += 3;
                }
                else
                {
                        b4_angle += 2;
                }
        }
        if(boss4.get_y() >= 20 && boss_state == B4_APPROACH)
        {
                boss4.set_speed(fix(0), fix(0));
                boss_state = B4_LASERFIRE;
        }
        if(boss_state == B4_LASERFIRE)
        {
                misc_counter++;
                if(misc_counter >= 20)
                {
                        misc_counter = 0;
                        misc_counter2++;
                        generate_boss_laser(&boss_laser_gun[0]);
                        t3ss_play_sound(bomb_sound, t3ss_place_sound(boss_laser_gun[0].get_ox(), 318), I_NULL);
                        if(misc_counter2 >= 20)
                        {
                                misc_counter2 = 0;
                                boss_state = B4_BOMBFIRE;
                        }
                }
        }
        if(boss_state == B4_BOMBFIRE)
        {
                misc_counter++;
                if(misc_counter >= 20)
                {
                        misc_counter = 0;
                        misc_counter2++;
                        generate_boss_bomb(&boss_gun);
                        if(misc_counter2 >= 20)
                        {
                                misc_counter2 = 0;
                                boss_state = B4_HUGELASER;
                        }
                }
        }
        if(boss_state == B4_HUGELASER)
        {
                misc_counter++;
                if(misc_counter == 50)
                {
                        big_laser_frame = 0;
                        boss4.spawn(&big_laser, fix(8), fix(28), fix(0), fix(0));
                        t3ss_play_sound_reserved(big_laser_sound, 1, I_NULL, I_NULL);
                }
                if(misc_counter >= 50)
                {
                        big_laser_frame++;
                        if(big_laser_frame >= 30)
                        {
                                big_laser_frame = 0;
                                t3ss_play_sound_reserved(big_laser_sound, 1, I_NULL, I_NULL);
                        }
                }
                if(misc_counter >= 250)
                {
                        misc_counter = 0;
                        big_laser.deactivate();
                        boss_state = B4_LASERFIRE;
                }
        }
        if(boss4.active())
        {
                if(boss_sframe % 20 == 0)
                {
                        t3ss_play_sound(ufo_sound, t3ss_place_sound(boss4.get_ox(), 318), I_NULL);
                }
                boss_sframe++;
        }
}

void do_boss(int num)
{
        int defeated = 0;
        int boss_life;

        tempvol = music_volume;
        astro_state = ASTRO_STATE_BOSS;
        if(num == 1)
        {
                boss_life = 100;
                boss_state = 0;
                misc_counter = 0;
                misc_counter2 = 0;
                boss2_charge = 0;
                while(!defeated && lives > 0 && !astro_exited)
                {
                        astro_control();
                        astro_move_sprites();
                        if(!astro_exited)
                        {
                                do_boss2();
                        }
                        for(int i = 0; i < MAX_LASERS; i++)
                        {
                                if(boss2.collide_perfect(&laser[i]))
                                {
                                        t3ss_play_sound(hit_sound, t3ss_place_sound(laser[i].get_ox(), 318), I_NULL);
                                        boss_life--;
                                        if(boss_life == 0)
                                        {
                                                t3ss_stop_mod();
                                                t3ss_play_mod(NULL);
                                                defeated = 1;
                                                generate_explosion_ex(&boss2);
                                                generate_explosion_ex(&boss_laser_gun[0]);
                                                generate_explosion_ex(&boss_laser_gun[1]);
                                                t3ss_play_sound_reserved(die_sound, 1, t3ss_place_sound(boss2.get_ox(), 318), I_NULL);
                                                boss2.deactivate();
                                                boss_laser_gun[0].deactivate();
                                                boss_laser_gun[1].deactivate();
                                                score += 2000;
                                                lives++;
                                                t3ss_play_sound_reserved(one_up_sound, 0, I_NULL, I_NULL);
                                                lives_up = score / 4000 * 4000 + 4000;
                                        }
                                        else
                                        {
                                                boss2.flash();
                                        }
                                        laser[i].deactivate();
                                }
                                for(int j = 0; j < 2; j++)
                                {
                                        if(boss_laser_gun[j].collide_perfect(&laser[i]))
                                        {
                                                t3ss_play_sound(land_sound, t3ss_place_sound(laser[i].get_ox(), 318), I_NULL);
                                                boss_laser_gun[j].flash();
                                                laser[i].deactivate();
                                        }
                                }
                        }
                        p_meter = boss_life;
                        get_peak_score();
                        astro_update();
                }
                do_endlevel();
        }
        else if(num == 3)
        {
                boss_life = 100;
                boss_state = 0;
                anglea = 64;
                angleb = 192;
                while(!defeated && lives > 0 && !astro_exited)
                {
                        astro_control();
                        astro_move_sprites();
                        if(!astro_exited)
                        {
                                do_boss1();
                        }
                        for(int i = 0; i < MAX_LASERS; i++)
                        {
                                if(boss1.collide_perfect(&laser[i]))
                                {
                                        t3ss_play_sound(hit_sound, t3ss_place_sound(laser[i].get_ox(), 318), I_NULL);
                                        boss_life--;
                                        if(boss_life == 0)
                                        {
                                                t3ss_stop_mod();
                                                t3ss_play_mod(NULL);
                                                defeated = 1;
                                                generate_explosion_ex(&boss1);
                                                generate_explosion_ex(&boss1_shield[0]);
                                                generate_explosion_ex(&boss1_shield[1]);
                                                t3ss_play_sound_reserved(die_sound, 1, t3ss_place_sound(boss2.get_ox(), 318), I_NULL);
                                                boss1.deactivate();
                                                boss1_shield[0].deactivate();
                                                boss1_shield[1].deactivate();
                                                score += 4000;
                                                lives++;
                                                t3ss_play_sound_reserved(one_up_sound, 0, I_NULL, I_NULL);
                                                lives_up = score / 4000 * 4000 + 4000;
                                        }
                                        else
                                        {
                                                boss1.flash();
                                        }
                                        laser[i].deactivate();
                                }
                                for(int j = 0; j < 2; j++)
                                {
                                        if(boss1_shield[j].collide_perfect(&laser[i]))
                                        {
                                                t3ss_play_sound(land_sound, t3ss_place_sound(laser[i].get_ox(), 318), I_NULL);
                                                boss1_shield[j].flash();
                                                laser[i].deactivate();
                                        }
                                }
                        }
                        p_meter = boss_life;
                        get_peak_score();
                        astro_update();
                }
                do_endlevel();
        }
        else if(num == 5)
        {
                boss_life = 50;
                boss_state = 0;
                b3_distance = 11;
                misc_counter = 0;
                while(!defeated && lives > 0 && !astro_exited)
                {
                        astro_control();
                        astro_move_sprites();
                        if(!astro_exited)
                        {
                                do_boss3();
                        }
                        for(int i = 0; i < MAX_LASERS; i++)
                        {
                                for(int j = 0; j < 2; j++)
                                {
                                        if(boss3a[j].collide_perfect(&laser[i]))
                                        {
                                                t3ss_play_sound(land_sound, t3ss_place_sound(laser[i].get_ox(), 318), I_NULL);
                                                boss3a[j].flash();
                                                laser[i].deactivate();
                                                misc_counter = 0;
                                        }
                                }
                                if(boss3b.collide_perfect(&laser[i]))
                                {
                                        t3ss_play_sound(hit_sound, t3ss_place_sound(laser[i].get_ox(), 318), I_NULL);
                                        boss_life--;
                                        if(boss_life == 0)
                                        {
                                                t3ss_stop_mod();
                                                t3ss_play_mod(NULL);
                                                defeated = 1;
                                                generate_explosion_ex(&boss3b);
                                                generate_explosion_ex(&boss3a[0]);
                                                generate_explosion_ex(&boss3a[1]);
                                                t3ss_play_sound_reserved(die_sound, 1, t3ss_place_sound(boss2.get_ox(), 318), I_NULL);
                                                boss3b.deactivate();
                                                boss3a[0].deactivate();
                                                boss3a[1].deactivate();
                                                score += 6000;
                                                lives++;
                                                t3ss_play_sound_reserved(one_up_sound, 0, I_NULL, I_NULL);
                                                lives_up = score / 4000 * 4000 + 4000;
                                        }
                                        else
                                        {
                                                boss3b.flash();
                                        }
                                        laser[i].deactivate();
                                }
                        }
                        p_meter = boss_life * 2;
                        get_peak_score();
                        astro_update();
                }
                do_endlevel();
        }
        else if(num == 8)
        {
                boss_life = 100;
                boss_state = 0;
                b4_angle = 0;
                misc_counter = 0;
                misc_counter2 = 0;
                while(!defeated && lives > 0 && !astro_exited)
                {
                        astro_control();
                        astro_move_sprites();
                        if(!astro_exited)
                        {
                                do_boss4();
                        }
                        for(int i = 0; i < MAX_LASERS; i++)
                        {
                                if(boss4.collide_perfect(&laser[i]))
                                {
                                        t3ss_play_sound(hit_sound, t3ss_place_sound(laser[i].get_ox(), 318), I_NULL);
                                        boss_life--;
                                        if(boss_life == 0)
                                        {
                                                t3ss_stop_mod();
                                                t3ss_play_mod(NULL);
                                                defeated = 1;
                                                generate_explosion_ex(&boss4);
                                                generate_explosion_ex(&boss_laser_gun[0]);
                                                generate_explosion_ex(&boss_gun);
                                                t3ss_play_sound_reserved(die_sound, 1, t3ss_place_sound(boss2.get_ox(), 318), I_NULL);
                                                boss4.deactivate();
                                                boss_laser_gun[0].deactivate();
                                                boss_gun.deactivate();
                                                big_laser.deactivate();
                                                score += 10000;
                                                lives++;
                                                t3ss_play_sound_reserved(one_up_sound, 0, I_NULL, I_NULL);
                                                lives_up = score / 4000 * 4000 + 4000;
                                        }
                                        else
                                        {
                                                boss4.flash();
                                        }
                                        laser[i].deactivate();
                                }
                                if(boss_laser_gun[0].collide_perfect(&laser[i]))
                                {
                                        boss_laser_gun[0].flash();
                                        t3ss_play_sound(land_sound, t3ss_place_sound(laser[i].get_ox(), 318), I_NULL);
                                        laser[i].deactivate();
                                }
                                if(boss_gun.collide_perfect(&laser[i]))
                                {
                                        boss_gun.flash();
                                        t3ss_play_sound(land_sound, t3ss_place_sound(laser[i].get_ox(), 318), I_NULL);
                                        laser[i].deactivate();
                                }
                        }
                        if(turret.collide_perfect(&big_laser))
                        {
                                astro_death();
                                boss_state = B4_LASERFIRE;
                        }
                        p_meter = boss_life;
                        get_peak_score();
                        astro_update();
                }
                for(int i = 0; i < MAX_UFO_BOMBS; i++)
                {
                        ufo_bomb[i].deactivate();
                }
                for(int i = 0; i < 5; i++)
                {
                        boss_laser[i].deactivate();
                }
                do_endlevel();
                if(!astro_exited && astro_state != ASTRO_STATE_GAME_OVER)
                {
                        astro_state = ASTRO_STATE_GAME_COMPLETE;
                        while(lives > 0)
                        {
                                misc_counter++;
                                if(misc_counter % 5 == 0)
                                {
                                        score += 1000;
                                        lives--;
                                        get_peak_score();
                                        t3ss_play_sound_reserved(hit_sound, 0, I_NULL, I_NULL);
                                }
                                astro_control();
                                astro_move_sprites();
                                astro_update();
                        }
                }
        }
        if(astro_state != ASTRO_STATE_GAME_OVER && astro_state != ASTRO_STATE_GAME_COMPLETE && !astro_exited)
        {
                for(int i = 0; i < 120; i++)
                {
                        astro_control();
                        astro_move_sprites();
                        astro_update();
                }
                t3ss_stop_mod();
                t3ss_play_mod(game_music_file[music_mode]);
                astro_state = ASTRO_STATE_PLAYING;
        }
}
