#ifndef EXTERNS_H
#define EXTERNS_H

/* game stuff */
extern ANIMATION    big_asteroid_animation[MAX_BIG_ASTEROID_TYPES];
extern ANIMATION    small_asteroid_animation[MAX_SMALL_ASTEROID_TYPES];
extern ANIMATION    turret_animation;
extern ANIMATION    laser_animation;
extern ANIMATION    small_spinner_animation;
extern ANIMATION    big_spinner_animation;
extern ANIMATION    pulsar_animation;
extern ANIMATION    ufo_animation;
extern ANIMATION    ufo_bomb_animation;
extern ANIMATION    explosion_animation;
extern ANIMATION    shrapnel_animation[MAX_SHRAPNEL_TYPES];
extern BASIC_SPRITE big_asteroid[MAX_BIG_ASTEROIDS];
extern int big_asteroid_type[MAX_BIG_ASTEROIDS];
extern BASIC_SPRITE small_asteroid[MAX_SMALL_ASTEROIDS];
extern BASIC_SPRITE turret;
extern BASIC_SPRITE laser[MAX_LASERS];
extern BASIC_SPRITE small_spinner[MAX_SMALL_SPINNERS];
extern BASIC_SPRITE big_spinner[MAX_BIG_SPINNERS];
extern BASIC_SPRITE pulsar[MAX_PULSARS];
extern BASIC_SPRITE ufo[MAX_UFOS];
extern BASIC_SPRITE ufo_bomb[MAX_UFO_BOMBS];
extern BASIC_SPRITE magic_bomb[MAX_UFO_BOMBS];
extern BASIC_SPRITE explosion[MAX_EXPLOSIONS];
extern BASIC_SPRITE shrapnel[MAX_SHRAPNEL];
extern BASIC_SPRITE boss1;
extern BASIC_SPRITE boss1_shield[2];
extern BASIC_SPRITE boss2;
extern BASIC_SPRITE boss_laser_gun[2];
extern BASIC_SPRITE boss_gun;
extern BASIC_SPRITE boss_laser[5];
extern BASIC_SPRITE boss3a[2];
extern BASIC_SPRITE boss3b;
extern BASIC_SPRITE boss4;
extern BASIC_SPRITE big_laser;
extern NCDFONT astro_font;

extern fix drop_speed_chart[10];
extern int big_asteroid_score[MAX_LEVELS];
extern int small_asteroid_score[MAX_LEVELS];
extern int big_spinner_score[MAX_LEVELS];
extern int small_spinner_score[MAX_LEVELS];
extern int pulsar_score[MAX_LEVELS];
extern int ufo_score[MAX_LEVELS];
extern int big_asteroid_lose[MAX_LEVELS];
extern int small_asteroid_lose[MAX_LEVELS];
extern int lose_amount[MAX_LEVELS];
extern long level_change[MAX_LEVELS];
extern int level_color[MAX_LEVELS];
extern fix level_multiplier[MAX_LEVELS];
extern int asteroid_prob[MAX_LEVELS];
extern int asteroid_split_prob[MAX_LEVELS];
extern int spinner_prob[MAX_LEVELS];
extern int pulsar_prob[MAX_LEVELS];
extern int ufo_prob[MAX_LEVELS];
extern int ufo_fire_time[MAX_LEVELS];
extern int lives_up;
extern int ufofire;

extern PALETTE astro_palette;
extern BITMAP * astro_screen;
extern BITMAP * astro_bgpic;
extern char lbrelease;
extern char rbrelease;
extern int lose;
extern long score;
extern long peakscore;
extern int level;
extern int lives;
extern int big_spinner_sframe[MAX_BIG_SPINNERS]; 
extern int small_spinner_sframe[MAX_SMALL_SPINNERS]; 
extern int ufo_sframe[MAX_UFOS]; 

extern MSAMPLE * laser_sound;
extern MSAMPLE * explode_sound;
extern MSAMPLE * land_sound;
extern MSAMPLE * one_up_sound;
extern MSAMPLE * die_sound;
extern MSAMPLE * missile_sound;
extern MSAMPLE * spinner_sound;
extern MSAMPLE * warp_sound;
extern MSAMPLE * bomb_sound;
extern MSAMPLE * ufo_sound;
extern MSAMPLE * hit_sound;
extern MSAMPLE * big_laser_sound;
extern MSAMPLE * secret_sound_1;
extern MSAMPLE * secret_sound_2;

extern int astro_state;
extern int astro_mode;

extern BITMAP * titlepic;
extern BITMAP * optionspic;
extern BITMAP * completepic;
extern ANIMATION select_animation;
extern MY_MENU astro_menu[ASTRO_MAX_MENUS];
extern char astro_quit;
extern char astro_exited;

extern char * title_music_file[3];
extern char * game_music_file[3];
extern char * astro_music_name[3];
extern char * boss_music_file[3];
extern char * hi_music_file[3];
extern char * sound_text[2];
extern char * soundcard_text[4];
extern char * joy_text[2];

extern unsigned char music_mode;
extern unsigned char sound_mode;
extern unsigned char music_volume;
extern unsigned char sound_volume;
extern unsigned char joystick_mode;
extern unsigned char sound_enabled;
extern int js_on;
extern int p_meter;
extern unsigned char b4_angle;
extern int boss_state;
extern int misc_counter;
extern int misc_counter2;
extern char bonus_enabled;

extern HISCORES classic_scores;
extern HISCORES survival_scores;
extern HISCORES deluxe_scores;

extern char ncd_joy_enabled;

#endif
