#include "includes.h"

BITMAP * hspic;

void hs_update(HISCORES * sp)
{
    blit(hspic, astro_screen, 0, 0, 0, 0, 318, 200);
    for(int i = 0; i < 5; i++)
    {
        ncd_printf(astro_screen, &astro_font, 71, 80 + i * 16, "%s", sp->get_name(i));
        ncd_printf(astro_screen, &astro_font, 71, 80 + i * 16, "    %7d", sp->get_score(i));
    }
    vsync();
    stretch_blit(astro_screen, screen, 0, 0, 318, 200, 1*2, 0*2, 318*2, 480);
}

void hs_enter_name(HISCORES * sp, int spot)
{
    char tempname[4] = {'_', 0, 0, 0};
    char tempkey = 0;
    int currentchar = 0;

    while(currentchar < 3 && tempkey != 0xD && tempkey != 0x1B)
    {
        tempkey = readkey() & 0xFF;
        if(tempkey == '\b')
        {
            if(currentchar > 0)
            {
                tempname[currentchar] = '\0';
                currentchar--;
                tempname[currentchar] = '_';
            }
        }
        else if(tempkey == 0xD || tempkey == 0x1B)
        {
            tempname[currentchar] = '\0';
        }
        else
        {
            /* automatically uppercase the letter */
            if(tempkey >= 'a' && tempkey <= 'z')
            {
                tempkey -= 32;
            }
            tempname[currentchar] = tempkey;
            currentchar++;
            if(currentchar < 3)
            {
                tempname[currentchar] = '_';
            }
        }
        sp->put_name(tempname, spot);
        hs_update(sp);
    }
    tempname[currentchar] = '\0';
    sp->put_name(tempname, spot);
}

void astro_hiscores(HISCORES * sp)
{
    int place = sp->place(peakscore);

    hspic = load_pcx(DATADIR "astro.dat#high_score_screen", NULL);
    set_palette(black_palette);
    if(place >= 0)
    {
        sp->make_room(place);
        sp->put_score(peakscore, place);
        sp->put_name("_  ", place);
    }
    hs_update(sp);
    t3ss_play_mod(hi_music_file[music_mode]);
    fade_in(astro_palette, 2);
    clear_keybuf();
    if(place >= 0)
    {
        hs_enter_name(sp, place);
    }
    ncd_joy_poll();
    while(!keypressed() && !ncd_joy_button(0, 0) && !ncd_joy_button(0, 1))
    {
        ncd_joy_poll();
    }
    fade_out(2);
    t3ss_stop_mod();
    destroy_bitmap(hspic);
}
