#ifndef MENU_H
#define MENU_H

#include "includes.h"

#define MAX_MENU_ITEMS 32

class MY_MENU_ITEM
{

public:

    MY_MENU_ITEM();
    void initialize(char * itext, int ix, int iy, int ox, int oy, void(*lp)(), void(*rp)(), void(*ep)());
    void rename(char * itext);
    int get_x(void);
    int get_y(void);
    int get_ox(void);
    int get_oy(void);
    void do_left_proc(void);
    void do_right_proc(void);
    void do_enter_proc(void);
    void draw(BITMAP * bp, NCDFONT * fp);

private:

    /* data */
    char text[128];
    int x, y;
    int is_ox, is_oy;

    /* procedures */
    void(*left_proc)();
    void(*right_proc)();
    void(*enter_proc)();

};

class MY_MENU
{

public:

    MY_MENU();
    void initialize(void(*up)(), NCDFONT * fp, ANIMATION * ap);
    void add_item(char * itext, int ix, int iy, int ox, int oy, void(*lp)(), void(*rp)(), void(*ep)());
    void rename_item(int inum, char * itext);
    void set_parent(int ip);
    int get_parent(void);
    void select_item(int inum);
    void clear(void);
    void activate(void);
    void deactivate(void);
    void do_controls(void);
    void draw(BITMAP * bp);

private:

    MY_MENU_ITEM item[MAX_MENU_ITEMS];
    ANIMATION * sel_anim;
    NCDFONT * menu_font;
    int sel_anim_frame;
    int item_count;
    int active;
    int selected_item;
    int parent;
    void(*update_proc)();

};

#endif
