#include "includes.h"

BITMAP * simon_pic[5];
MSAMPLE * simon_sound[5] = {0};
char simon_over = 0;
int simon_lit = 0;
char simon_ready = 0;
char simon_lready = 1;
char simon_rready = 1;
char simon_uready = 1;
char simon_dready = 1;
char simon_chart[1000];
char simon_count = 0;
char you_count = 0;

void simon_init(void)
{
    simon_pic[0] = load_pcx(DATADIR "astro.dat#simon_0", NULL);
    simon_pic[1] = load_pcx(DATADIR "astro.dat#simon_1", NULL);
    simon_pic[2] = load_pcx(DATADIR "astro.dat#simon_2", NULL);
    simon_pic[3] = load_pcx(DATADIR "astro.dat#simon_3", NULL);
    simon_pic[4] = load_pcx(DATADIR "astro.dat#simon_4", NULL);
    simon_sound[1] = t3ss_load_wav_fn(DATADIR "astro.dat#simon_sound_1");
    simon_sound[2] = t3ss_load_wav_fn(DATADIR "astro.dat#simon_sound_2");
    simon_sound[3] = t3ss_load_wav_fn(DATADIR "astro.dat#simon_sound_3");
    simon_sound[4] = t3ss_load_wav_fn(DATADIR "astro.dat#simon_sound_4");

    simon_over = 0;
    simon_count = 0;
}

void simon_exit(void)
{
    for(int i = 0; i < 5; i++)
    {
        destroy_bitmap(simon_pic[i]);
        t3ss_free_wav(simon_sound[i]);
    }
}

void simon_pick(void)
{
    simon_chart[simon_count] = ncd_random() % 4 + 1;
    simon_count++;
}

void simon_update(void)
{
    if(key[KEY_ESC])
    {
        simon_over = 1;
    }
    if(!simon_over)
    {
        clear(astro_screen);
        draw_sprite(astro_screen, simon_pic[simon_lit], 69, 10);
        ncd_draw_number(astro_screen, &astro_font, 286, 184, simon_count - 1 >= 0 ? simon_count - 1 : 0, 2);
        vsync();
        stretch_blit(astro_screen, screen, 0, 0, 320, 200, 1*2, 0*2, 320*2, 480);
    }
}

int you_pick(void)
{
    simon_lit = 0;
    while(!key[KEY_ESC] && !key[KEY_LEFT] && !key[KEY_RIGHT] && !key[KEY_UP] && !key[KEY_DOWN] && !ncd_joy_left(0) && !ncd_joy_right(0) && !ncd_joy_up(0) && !ncd_joy_down(0) && !simon_over)
    {
        ncd_joy_poll();
        simon_update();
    }
    if(key[KEY_UP] || ncd_joy_up(0))
    {
        simon_lit = 1;
        simon_ready = 30;
        simon_uready = 0;
    }
    else if(key[KEY_LEFT] || ncd_joy_left(0))
    {
        simon_lit = 2;
        simon_ready = 30;
        simon_lready = 0;
    }
    else if(key[KEY_RIGHT] || ncd_joy_right(0))
    {
        simon_lit = 3;
        simon_ready = 30;
        simon_rready = 0;
    }
    else if(key[KEY_DOWN] || ncd_joy_down(0))
    {
        simon_lit = 4;
        simon_ready = 30;
        simon_dready = 0;
    }
    return simon_lit;
}

void do_simon(void)
{
    simon_pick();
    for(int i = 0; i < simon_count; i++)
    {
        simon_lit = simon_chart[i];
        if(!simon_over)
        {
            t3ss_play_sound(simon_sound[simon_lit], -1, -1);
        }
        for(int j = 0; j < 30; j++)
        {
            ncd_joy_poll();
            simon_update();
        }
        simon_lit = 0;
        for(int j = 0; j < 5; j++)
        {
            simon_update();
        }
    }
}

void do_you(void)
{
    for(int i = 0; i < simon_count; i++)
    {
        simon_lit = you_pick();
        if(!simon_over)
        {
            t3ss_play_sound(simon_sound[simon_lit], -1, -1);
        }
        for(int j = 0; j < 30; j++)
        {
            ncd_joy_poll();
            simon_update();
        }
        if(simon_lit != simon_chart[i])
        {
            simon_over = 1;
        }
        simon_lit = 0;
        for(int j = 0; j < 5; j++)
        {
            simon_update();
        }
    }
}

void play_simon(void)
{
    simon_init();
    t3ss_play_mod(NULL);
    simon_update();
    fade_in(astro_palette, 3);
    while(!simon_over)
    {
        do_simon();
        do_you();
        simon_update();
    }
    fade_out(3);
    t3ss_stop_mod();
    simon_exit();
}
