#include "includes.h"

#define SPINNER_SPEED level < 3 ? drop_speed_chart[(ncd_random() % 6) + 1] : drop_speed_chart[ncd_random() % 7]
#define SPINNER_DELAY 120

int spinner_time = 0;

void generate_spinner(void)
{
    fix r_x;
    fix r_s;
    fix t_drop;

    if(chance(1000, PROB_TOTAL))
    {
        for(int i = 0; i < MAX_SMALL_SPINNERS; i++)
        {
            if(!small_spinner[i].active())
            {
                small_spinner_sframe[i] = 0;
                r_x = ncd_random() % 302;
                small_spinner[i].set_position(r_x, fix(-160));
                if(chance(500, PROB_TOTAL))
                {
                    r_s = (ncd_random() % 3) - 1;

                    if(r_x < 80 && r_s < 0)
                    {
                        r_s = -r_s;
                    }
                    else if(r_x >= 224 && r_s > 0)
                    {
                        r_s = -r_s;
                    }

                    t_drop = SPINNER_SPEED;
                    if(r_s < 0)
                    {
                        small_spinner[i].set_speed(-(t_drop / 4), t_drop);
                    }
                    else if(r_s == 0)
                    {
                        small_spinner[i].set_speed(fix(0), t_drop);
                    }
                    else
                    {
                        small_spinner[i].set_speed(t_drop / 4, t_drop);
                    }
                }
                else
                {
                    small_spinner[i].set_speed(fix(0), fix(SPINNER_SPEED));
                }
                small_spinner[i].activate();
                break;
            }
        }
    }
    else
    {
        for(int i = 0; i < MAX_BIG_SPINNERS; i++)
        {
            if(!big_spinner[i].active())
            {
                big_spinner_sframe[i] = 0;
                r_x = ncd_random() % 286;
                big_spinner[i].set_position(r_x, fix(-32));
                if(chance(500, PROB_TOTAL))
                {
                    r_s = (ncd_random() % 3) - 1;

                    if(r_x < 80 && r_s < 0)
                    {
                        r_s = -r_s;
                    }
                    else if(r_x > 208 && r_s > 0)
                    {
                        r_s = -r_s;
                    }

                    t_drop = SPINNER_SPEED;
                    if(r_s < 0)
                    {
                        big_spinner[i].set_speed(-(t_drop / 4), t_drop);
                    }
                    else if(r_s == 0)
                    {
                        big_spinner[i].set_speed(fix(0), t_drop);
                    }
                    else
                    {
                        big_spinner[i].set_speed(t_drop / 4, t_drop);
                    }
                }
                else
                {
                    big_spinner[i].set_speed(fix(0), fix(SPINNER_SPEED));
                }
                big_spinner[i].activate();
                break;
            }
        }
    }
}

void generate_spinners(void)
{
    if(spinner_time > 0) spinner_time--;
    if(chance(spinner_prob[level], PROB_TOTAL) && spinner_time == 0 && astro_state != ASTRO_STATE_BOSS && astro_state != ASTRO_STATE_LEVEL_COMPLETE && astro_state != ASTRO_STATE_GAME_COMPLETE)
    {
        generate_spinner();
        spinner_time = SPINNER_DELAY;
    }
}

void move_spinners(void)
{
    for(int i = 0; i < MAX_SMALL_SPINNERS; i++)
    {
        small_spinner[i].update_position();
        if(small_spinner[i].collide_rect(fix(0), fix(172), fix(3200), fix(20)))
        {
            if(astro_state == ASTRO_STATE_PLAYING || astro_state == ASTRO_STATE_BOSS)
            {
                astro_death();
            }
            else
            {
                small_spinner[i].deactivate();
            }
        }
        if(small_spinner_sframe[i] % 15 == 0 && small_spinner[i].active())
        {
            t3ss_play_sound(spinner_sound, t3ss_place_sound(small_spinner[i].get_ox(), 318), I_NULL);
        }
        if(small_spinner[i].active())
        {
            small_spinner_sframe[i]++;
        }
    }
    for(int i = 0; i < MAX_BIG_SPINNERS; i++)
    {
        big_spinner[i].update_position();
        if(big_spinner[i].collide_rect(fix(0), fix(172), fix(320), fix(20)))
        {
            if(astro_state == ASTRO_STATE_PLAYING || astro_state == ASTRO_STATE_BOSS)
            {
                astro_death();
            }
            else
            {
                big_spinner[i].deactivate();
            }
        }
        if(big_spinner_sframe[i] % 15 == 0 && big_spinner[i].active())
        {
            t3ss_play_sound(spinner_sound, t3ss_place_sound(big_spinner[i].get_ox(), 318), I_NULL);
        }
        if(big_spinner[i].active())
        {
            big_spinner_sframe[i]++;
        }
    }
}

void do_spinners(void)
{
    generate_spinners();
    move_spinners();
}
