#include "includes.h"

void generate_ufos(void)
{
    if(level >= 3 && chance(ufo_prob[level], PROB_TOTAL) && astro_state != ASTRO_STATE_BOSS && astro_state != ASTRO_STATE_LEVEL_COMPLETE && astro_state != ASTRO_STATE_GAME_COMPLETE)
    {
        for(int i = 0; i < MAX_UFOS; i++)
        {
            if(!ufo[i].active())
            {
                ufo_sframe[i] = 0;
                if(chance(1000, PROB_TOTAL))
                {
                    ufo[i].set_position(fix(-ufo_animation.w), fix(ncd_random() % 40));
                    ufo[i].set_speed(fix(1), fix(0));
                }
                else
                {
                    ufo[i].set_position(fix(320), fix(ncd_random() % 40));
                    ufo[i].set_speed(fix(-1), fix(0));
                }
                ufo[i].activate();
                ufofire = 1;
                break;
            }
        }
    }
}

void move_ufos(void)
{
    for(int i = 0; i < MAX_UFOS; i++)
    {
        ufo[i].update_position();
        if(ufofire % ufo_fire_time[level] == 0 && ufo[i].active() && ufo[i].get_ox() >= 0 && ufo[i].get_ox() < 318 && (astro_state == ASTRO_STATE_PLAYING || astro_state == ASTRO_STATE_BOSS))
        {
            for(int j = 0; j < MAX_UFO_BOMBS; j++)
            {
                if(!ufo_bomb[j].active())
                {
                    t3ss_play_sound(bomb_sound, t3ss_place_sound(ufo[i].get_ox(), 318), I_NULL);
                    ufo[i].spawn(&ufo_bomb[j], fix(16), fix(13), fix(0), fix(0));
                    ufo_bomb[j].follow_center(&turret, 3);
                    break;
                }
            }
        }
        ufofire++;
        if(ufo_sframe[i] % 20 == 0 && ufo[i].active())
        {
            t3ss_play_sound(ufo_sound, t3ss_place_sound(ufo[i].get_ox(), 318), I_NULL);
        }
        if(ufo[i].active())
        {
            ufo_sframe[i]++;
        }
    }
}

void do_ufos(void)
{
    generate_ufos();
    move_ufos();
}
